unit KoordRuu;
{
   TKoodRuutu  - erikoistapaus ruudusta, joka nytt koordinaatinsa
                 ja voi liikkua itsenisesti.
   TLautaKoodr - erikoistapaus laudasta, joka voi tallettaa mys
                 TKoordRuutu -tyyppisi ruutuja.

   13.10.1997/Vesa Lappalainen
}
interface
uses Classes,
{$ifdef CLX}
  QStdCtrls,QExtCtrls,
{$else}
  StdCtrls,ExtCtrls,
{$endif}
  Lauta,Ruutu;

type
  TKoordRuutu = class(TRuutu)
  private
    dx, dy : integer;
    FLabel : TLabel;
    FTimer : TTimer;
  protected
    procedure TimerTimer(Sender: TObject);   virtual;
  public
    constructor Create(AOwner : TComponent); override;
    procedure SetLabel;                      virtual;
    procedure UpdateRuutu;                   override;
    procedure MeneKotiin;                    override;
    procedure Liiku;                         virtual;
    procedure Stop;                          virtual;
    procedure Go;                            virtual;
  published
  end;

type TProcKoordRuutu = procedure (r:TKoordRuutu);

type
  TLautaKoord = class(TLauta)
  private
  protected
  public
    procedure ForEveryKoordRuutu(proc:TProcKoordRuutu);  virtual;
    procedure Sekoita;                                   virtual;
    procedure Jatka;                                     virtual;
    procedure Seis;                                      virtual;
  published
  end;

procedure Register;


implementation
uses SysUtils,
{$ifdef CLX}
  QControls;
{$else}
  Controls;
{$endif}

// --------------------- TKoordRuutu -------------------------------------------
constructor TKoordRuutu.Create(AOwner : TComponent);
begin
  inherited;
  FLabel := TLabel.Create(self);
  FLabel.Parent := self;
  FLabel.Height := 12;
  FLabel.Align := alBottom;
  FLabel.Alignment := taCenter;
  FTimer := TTimer.Create(self);
  FTimer.Interval := 100;
  FTimer.Enabled := false;
  FTimer.OnTimer := TimerTimer;
end;

procedure TKoordRuutu.SetLabel;
begin
  FLabel.Caption := '(' + IntToStr(x) + ',' + IntToStr(y) + ')';
end;

procedure TKoordRuutu.UpdateRuutu;
begin
  SetKoko;
  SetLabel;
  MeneKotiin;
end;

procedure TKoordRuutu.MeneKotiin;
begin
  Stop;
  inherited;
end;

procedure TKoordRuutu.Liiku;
begin
  top := Random(Parent.ClientHeight-Height);
  left := Random(Parent.ClientWidth-Width);
  dx := -3 + Random(7);
  dy := -3 + Random(7);
  Go;
end;

procedure TKoordRuutu.TimerTimer(Sender: TObject);
begin
  if ( top + dy < 0 ) then dy := abs(dy);
  if ( top + dy >= Parent.ClientHeight-Height ) then dy := -abs(dy);
  if ( left + dx < 0 ) then dx := abs(dx);
  if ( left + dx >= Parent.ClientWidth-Width ) then dx := -abs(dx);
  top  := top + dy;
  left := left + dx;
end;

//---------- TLautaKoord -------------------------------------------------------
procedure TLautaKoord.ForEveryKoordRuutu(proc:TProcKoordRuutu);
var i:integer; c : TControl;
begin
  for i:=0 to ControlCount-1 do begin
    c := Controls[i];
    if not ( c is TKoordRuutu ) then continue;
    proc(c as TKoordRuutu);
  end;
end;

procedure GoOn(c:TKoordRuutu); begin  c.Go; end;
procedure Arvo(c:TKoordRuutu); begin  c.Liiku; end;
procedure pause(c:TKoordRuutu); begin  c.Stop; end;

procedure TLautaKoord.Jatka;
begin
  ForEveryKoordRuutu(GoOn);
end;

procedure TLautaKoord.Seis;
begin
  ForEveryKoordRuutu(Pause);
end;

procedure TLautaKoord.Sekoita;
begin
  ForEveryKoordRuutu(Arvo);
end;

procedure TKoordRuutu.Stop;
begin
  FTimer.Enabled := false;
end;

procedure TKoordRuutu.Go;
begin
  FTimer.Enabled := true;
end;

procedure Register;
begin
  RegisterComponents('TicTac', [TKoordRuutu]);
  RegisterComponents('TicTac', [TLautaKoord]);
end;

end.
