unit Ruutu;
{
  Perusruutu, jonka plle voi pudottaa kontrollin ja tllin
  kontrollin is vaihtuu.

  Orsiruutu, joka voi tallettaa useita Kontrolleja.

  13.10.1997/Vesa Lappalainen 
}

interface

uses
  SysUtils, Classes, Types,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls,QExtCtrls;
{$else}
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs, stdctrls,ExtCtrls;
{$endif}

type
  TRuutu = class(TPanel)
  private
    FX : integer;
    FY : integer;
    FNappula : TControl;
  protected
    procedure RuutuDragOver(Sender, Source: TObject; X, Y: Integer;
              State: TDragState; var Accept: Boolean); virtual;
    procedure RuutuDragDrop(Sender, Source: TObject; X, Y: Integer); virtual;
  public
    constructor Create(AOwner : TComponent); override;
    procedure SetX(i:integer);               virtual;
    procedure SetY(i:integer);               virtual;
    procedure SetNappula(c:TControl);        virtual;
    procedure MeneKotiin;                    virtual;
    procedure SetKoko;                       virtual;
    procedure UpdateRuutu;                   virtual;
    property Nappula : TControl read FNappula write SetNappula;
  published
    property x : integer read FX write SetX;
    property y : integer read FY write SetY;
  end;

  TOrsiRuutu = class(TRuutu)
  private
  protected
    function GetNappula : TControl;          virtual;
  public
    procedure SetNappula(c:TControl);        override;
    property Nappula : TControl read GetNappula write SetNappula;
  published
  end;

procedure Register;

implementation

uses Lauta;

function Lauta(c:TControl):TLauta;
begin
  Result := NIL;
  if c = NIL then exit;
  if not ( c.Parent is TLauta ) then exit;
  Result := c.Parent as TLauta;
end;

constructor TRuutu.Create(AOwner : TComponent);
begin
  inherited;
  FX := 0;
  FY := 0;
  Caption := ' ';
  OnDragOver := RuutuDragOver;
  OnDragDrop := RuutuDragDrop;
end;

procedure TRuutu.MeneKotiin;
var L:TLauta; p : TPoint;
begin
  L := Lauta(self); if ( L = NIL ) then exit;
  p := L.MissaKoti(x,y);
  left := p.x;
  top  := p.y;
end;

procedure TRuutu.SetX(i:integer);
begin
  FX := i;
  UpdateRuutu;
end;

procedure TRuutu.SetY(i:integer);
begin
  FY := i;
  UpdateRuutu;
end;

procedure TRuutu.SetKoko;
var L:TLauta;
begin
  L := Lauta(self); if ( L = NIL ) then exit;
  Height := L.RuudunKorkeus;
  Width  := L.RuudunLeveys;
end;

procedure TRuutu.UpdateRuutu;
begin
  SetKoko;
  MeneKotiin;
end;


// Vain tyhjn ruutuun voidaan asettaa nappula.
procedure TRuutu.SetNappula(c:TControl);
var pr : TRuutu;
begin
  if ( Nappula <> nil ) then exit;
  FNappula := c;
  if ( c = nil ) then exit;
  if ( c.Parent is TRuutu ) then begin             // Jos asuu ruudussa
    pr := (c.Parent as TRuutu);
    if ( pr.Nappula = c ) then pr.FNappula := nil; // Vanha nappula pois
  end;
  c.Parent := self;
  FNappula := c;
end;


procedure TRuutu.RuutuDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := false;
  if ( Nappula <> nil ) then exit;
  if not ( Source is TControl ) then exit;
  Accept := true;
end;

procedure TRuutu.RuutuDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if ( Nappula <> nil ) then exit;
  if not ( Source is TControl ) then exit;
  Nappula := Source as TControl;
end;

// --------------------- TOrsiRuutu --------------------------------------------
procedure TOrsiRuutu.SetNappula(c:TControl);
begin
  FNappula := nil;
  inherited;
end;

function TOrsiRuutu.GetNappula : TControl;
begin
  Result := FNappula;
  if ( FNappula <> nil ) then exit;
  if ( ControlCount = 0 ) then exit;
  Result := Controls[0];
end;


procedure Register;
begin
  RegisterComponents('TicTac', [TRuutu]);
  RegisterComponents('TicTac', [TOrsiRuutu]);
end;

end.
