unit tictac;
{
  Tictac peli, jossa ruudut liikkuvat pelaajalta karkuun.
  Liikkuvissa ruuduissa on koordinaatit.  Pelin tarkoituksena
  on opetella koordinaatteja.

  Esimerkki Graafisten kyttliittymien kurssille 1997
  13.10.1997/Vesa Lappalainen
  13.10.2001/vl
    + VCL/CLX

  Luokat:
  =======
    TNappula                    Nappula.pas
      - itsens piirtminen
      - voi tarttua raahattavaksi

    TRuksi ( TNappula )         Nappula.pas
      - piirt ruksin

    TPallo ( TNappula )         Nappula.pas
      - piirt pallon

    TRuutu ( TPanel )           Ruutu.pas
      - koordinaatti paikasta
      - MeneKotiin
      - Ota nappula ( Nappula := )

    TOrsiRuutu ( TRuutu )       Ruutu.pas
      - voi tallettaa monta nappulaa

    TKoordRuutu ( TRuutu )      KoordRuu.pas
      - liikkuu ( Timer )
      - nytt koordinaatin

    TLauta ( TPanel )           Lauta.pas
      - MissaKoti(koordinaatti)
      - ruudun koko
      - ruutujen mr
      - ruudut ( osoitintaulukko, Controls )

    TLautaKoord ( TLauta )      KoordRuu.pas
      - lauta TKoordRuutu tyyppisille olioille jos tarvitaan liikkumista

    TOrsi (ei ole erikseen = Lauta)
      - pit nappuloita odottamassa valintaa
      - toteutuu laudasta jos sinne sijoitetaan TOrsiRuutuja

    TPeli  ( TForm )            tictac.pas
      - hoitelee koko hommaa

Tehtvi:
  1) Lis tapa yllpit vuoroa
  2) Lis siirtminen klikkaamalla ruutua johon siirretn
  3) Lis Tarkista nappulaan tuloksen tarkistus ja sen pelaajan
     nappulan poisto, joka tilasi tarkistuksen jollei tm voittanutkaan

}

interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls, QExtCtrls,
{$else}
  Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  ToolWin,ComCtrls, Windows, Messages,
{$endif}
  Lauta, Ruutu, KoordRuu, Nappula;

type
  TFormTicTac = class(TForm)
    Lauta: TLautaKoord;
    Orsi: TLauta;
    Ruutu1: TKoordRuutu;
    Ruutu2: TKoordRuutu;
    Ruutu3: TKoordRuutu;
    Ruutu4: TKoordRuutu;
    Ruutu5: TKoordRuutu;
    Ruutu6: TKoordRuutu;
    Ruutu7: TKoordRuutu;
    Ruutu8: TKoordRuutu;
    Ruutu9: TKoordRuutu;
    RuutuO: TOrsiRuutu;
    RuutuX: TOrsiRuutu;
//    ToolBar1: TToolBar;
    ToolBar1: TPanel;
    ButtonTarkista: TButton;
    ButtonUusipeli: TButton;
    ButtonLopeta: TButton;
    ButtonJatka: TButton;
    ButtonPause: TButton;
    NappulaO1: TNappulaO;
    NappulaO2: TNappulaO;
    NappulaO3: TNappulaO;
    NappulaO4: TNappulaO;
    NappulaO5: TNappulaO;
    NappulaO6: TNappulaO;
    NappulaX1: TNappulaX;
    NappulaX2: TNappulaX;
    NappulaX3: TNappulaX;
    NappulaX4: TNappulaX;
    NappulaX5: TNappulaX;
    NappulaX6: TNappulaX;
    procedure ButtonUusipeliClick(Sender: TObject);
    procedure ButtonTarkistaClick(Sender: TObject);
    procedure ButtonLopetaClick(Sender: TObject);
    procedure ButtonJatkaClick(Sender: TObject);
    procedure ButtonPauseClick(Sender: TObject);
  private
    procedure SiirraOrrelle(r:TRuutu);
  public
  end;

var
  FormTicTac: TFormTicTac;

implementation

{$ifndef CLX}
{$R *.dfm}
{$else}
{$R *.xfm}
{$endif}

procedure TFormTicTac.SiirraOrrelle(r:TRuutu);
begin
  if r.Nappula = nil then exit;
  if ( r.Nappula is TNappulaO ) then RuutuO.Nappula := r.Nappula;
  if ( r.Nappula is TNappulaX ) then RuutuX.Nappula := r.Nappula;
end;

procedure TFormTicTac.ButtonUusipeliClick(Sender: TObject);
begin
  Lauta.ForEveryRuutuM(SiirraOrrelle);
  Lauta.Sekoita;
end;

procedure TFormTicTac.ButtonTarkistaClick(Sender: TObject);
begin
  Lauta.Kotiuta;
end;

procedure TFormTicTac.ButtonLopetaClick(Sender: TObject);
begin
  Close;
end;

procedure TFormTicTac.ButtonJatkaClick(Sender: TObject);
begin
  Lauta.Jatka;
end;

procedure TFormTicTac.ButtonPauseClick(Sender: TObject);
begin
  Lauta.Seis;
end;

end.
